﻿:Namespace Boot

    ∇ Demo
      MSRoot←{(1-'\'⍳⍨⌽⍵)↓⍵}⎕WSID
      Run MSRoot,'demo'
    ∇

    ∇ End;classes;z;m
     
      ms.End
      ⎕EX⍕⊃⊃⎕CLASS ms.SessionHandler
      ⎕EX⍕⊃⊃⎕CLASS ms.Authentication
      ⎕EX⍕⊃⊃⎕CLASS ms
     
      :If 0≠⍴classes←↓#.⎕NL 9.4
      :AndIf 0≠⍴classes←(m←2=⊃∘⍴¨z←⎕CLASS¨#⍎¨classes)/classes
          classes←(#.MildPage≡¨2 1∘⊃¨m/z)/classes
          #.⎕EX↑⍕¨classes ⍝ Erase loaded classes
      :EndIf
     
      Load 0
     
      :If 0≠⎕NC'#.XL'
          :If #.XL.Workbooks.Count>0
              #.XL.(⌷Workbooks).(Close Saved←1)
          :EndIf
          #.XL.Quit
      :EndIf
     
      ⎕EX¨'XL' 'ms' 'AppRoot'
    ∇

    ∇ ms←Init Config;path;class;classes
     ⍝ Create instances of MildServer, Session and Authentication Handlers
     
      ms←⎕NEW(#⍎Config.ClassName)(Config.(Port Root Address))
      ms.DefaultPage←Config.DefaultPage
     
      path←MSRoot,'Extensions\'
     
      :If 0≠⍴Config.SessionHandler
          class←⎕SE.SALT.Load path,Config.SessionHandler
          ms.SessionHandler←⎕NEW class ms
      :EndIf
     
      :If 0≠⍴Config.Authentication
          class←⎕SE.SALT.Load path,Config.Authentication
          ms.Authentication←⎕NEW class ms
      :EndIf
    ∇

    ∇ Load yes;files;f;classes;class
      ⍝ Note: DRC, XML, SOAP namespaces are not SALTed
     
      classes←(⎕SE.SALT.List AppRoot,'Code -raw')[;2] ⍝ Classes in application folder
     
      :If yes
          files←'Core\'∘,¨'MildServer' 'MildPage' 'HTTPRequest'
          files,←'Utils\'∘,¨'Files' 'Dates' 'Strings' 'HTML' 'HTMLInput' 'Base64'
     
          :For f :In files
              ⎕SE.SALT.Load MSRoot,f,' -target=#'
          :EndFor
     
          :If 0≠⍴classes
              :For class :In classes
                  ⎕SE.SALT.Load AppRoot,'Code\',class,' -target=#'
              :EndFor
          :EndIf
     
    
      :Else ⍝ Cleanup
     
          #.⎕EX¨classes
          #.⎕EX¨'MildServer' 'MildPage' 'HTTPRequest' 'HTML' 'HTMLInput' 'Files' 'Dates' 'Strings' 'Base64'
      :EndIf
    ∇

    ∇ Run root;Config
     ⍝ Does not "Load"; assumes this has been done
     
      AppRoot←root,(~(¯1↑root)∊'\/')/'\'
     
      Load 1
     
      Config←#.XML.ToNS #.Files.GetText AppRoot,'Config\Server.xml'
      Config.Port←2 1⊃⎕VFI Config.Port
      Config.Root←MSRoot{((~':'∊⍵)/⍺),⍵}Config.Root
     
      ms←Init Config ⍝ Create instance of MildServer, Session and Authentication handlers
      ms.Run
    ∇

:EndNamespace